<?php
/* This is the form entry page that is used by hrecipe.php */
require_once('../../../wp-load.php'); // Ugly directory stuff
require_once('../../../wp-admin/admin.php'); // Ugly directory stuff
@header('Content-Type: ' . get_option('html_type') . '; charset=' . get_option('blog_charset'));
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" <?php do_action('admin_xml_ns'); ?> <?php language_attributes(); ?>>
<head>
<?php
wp_enqueue_style( 'global' );
wp_enqueue_style( 'wp-admin' );
wp_enqueue_style( 'colors' );
?>
<script type="text/javascript">//<!CDATA[
function clearForm()
{
	
document.getElementById('item-name').value = '';
document.getElementById('item-url').value = '';
document.getElementById('item-summary').value = '';
document.getElementById('item-ingredients').value = '';
document.getElementById('item-description').value = '';
document.getElementById('item-diettype').value = '';
document.getElementById('item-dietrestriction').value = '';
document.getElementById('item-culinarytradition').value = '';
document.getElementById('item-mealtype').value = '';
document.getElementById('item-servings').value = '';
document.getElementById('item-rating').value = '';
document.getElementById('item-duration').value = '';
}
function getSelectValue(fieldId)
{
  var selectItem = document.getElementById(fieldId);
  var selectValue = selectItem.value;
  if ("" != selectValue)
  {
    return selectValue;
  }
  // avoid bug in old browsers where they never give any value directly
  var selectIdx = selectItem.selectedIndex;
  selectValue = selectItem.options[selectIdx].value;
  if ("" != selectValue)
  {
    return selectValue;
  }
  // and cope with IE
  selectValue = (selectItem.options[selectIdx]).text;
  return selectValue;
}

// Process the checkboxes here.
// This can be processed as an 
// arrary traversing id's and names later.
// Suggestions welcome.
function getCheckedValues() {
	
	var need_comma = false;
	var comma = ', ';
	var diet = '';
	if (document.getElementById('low_calorie').checked) { 
	   diet += 'Low calorie';
	   need_comma = true; 
	}
	if (document.getElementById('reduced_fat').checked) { 
	   if (need_comma) diet += comma;
	   diet += 'Reduced fat'; 
	   need_comma = true; 
	}
	if (document.getElementById('reduced_carbohydrate').checked) { 
	   if (need_comma) diet += comma;
	   diet += 'Reduced carbohydrate'; 
	   need_comma = true; 
	}
	if (document.getElementById('high_protein').checked) { 
	   if (need_comma) diet += comma;
	   diet += 'High protein'; 
	   need_comma = true; 	   
	}
	if (document.getElementById('gluten_free').checked) { 
	   if (need_comma) diet += comma;
	   diet += 'Gluten free';
	   need_comma = true; 	    
	}
	if (document.getElementById('raw').checked) { 
	   if (need_comma) diet += comma;
	   diet += 'Raw'; 
	}

	return  diet;
}

function recipe() {}

function submitForm() {
	
   r = new recipe();
   r["name"] = document.getElementById('item-name').value;

   if ("" == r["name"]) {
      alert("You need to provide a name for the recipe.");
      return false;
   }

   r["url"] = document.getElementById('item-url').value;
   r["summary"] = document.getElementById('item-summary').value;
   r["ingredients"] = document.getElementById('item-ingredients').value;
   r["description"] = document.getElementById('item-description').value;
   
   r["tradition"] = getSelectValue('item-culinarytradition');
   r["rating"] = getSelectValue('item-rating');
   r["duration"] = document.getElementById('item-duration').value;
   r["diettype"] = getSelectValue('item-diettype');
   r["mealtype"] = getSelectValue('item-mealtype');
   r["dietother"] = getCheckedValues();
   r["restriction"] = document.getElementById('item-dietrestriction').value; 
   r["servings"] = document.getElementById('item-servings').value; 
   
   window.parent.edInsertHRecipeDone(r);
}

function abortForm()
{
window.parent.edInsertHRecipeAbort();
}
//]]>
</script>
<?php
do_action('admin_print_styles');
do_action('admin_print_scripts');
do_action('admin_head');
?>
</head>
<body<?php if ( isset($GLOBALS['body_id']) ) echo ' id="' . $GLOBALS['body_id'] . '"'; ?>>
<div class="wrap">
<h2><?php _e('New Recipe','hrecipe'); ?></h2>
<form name="recipeForm">
<p>
<table class="form-table">
<tr valign="top">
<th scope="row"><?php _e('Name of recipe','hrecipe'); ?> </th>
<td><input type="text" id="item-name" size="45" /></td>
</tr>
<tr valign="top">
<th scope="row"><?php _e('Reference URL','hrecipe'); ?></th>
<td><input type="text" id="item-url" size="45" /></td>
</tr>

<tr valign="top">
<th scope="row"><?php _e('Summary','hrecipe'); ?></th>
<td><input type="text" id="item-summary" size="45" /></td>
</tr>

<tr valign="top">
<th scope="row"><?php _e('Ingredients','hrecipe'); ?><br /><?php _e('(May use HTML)','hrecipe'); ?></th>
<td><textarea id="item-ingredients" rows="10" cols="45"></textarea></td>
</tr>


<tr valign="top">
<th scope="row"><?php _e('Description','hrecipe'); ?><br /><?php _e('(May use HTML)','hrecipe'); ?></th>
<td><textarea id="item-description" rows="10" cols="45"></textarea></td>
</tr>

<tr valign="top">
<th scope="row"><?php _e('Preparation time (minutes)','hrecipe'); ?></th>
<td><input type="text" id="item-duration" size="5" /></td>
</tr>

<tr valign="top">
<th scope="row"><?php _e('Recipe type:','hrecipe'); ?></th>
<td>
<select id="item-mealtype">
<option></option>
<option><?php _e('breakfast','hrecipe'); ?></option>
<option><?php _e('lunch','hrecipe'); ?></option>
<option><?php _e('dinner','hrecipe'); ?></option>
<option><?php _e('supper','hrecipe'); ?></option>
<option><?php _e('brunch','hrecipe'); ?></option>
<option><?php _e('dessert','hrecipe'); ?></option>
<option><?php _e('cocktail','hrecipe'); ?></option>
<option><?php _e('hors d\'oerves','hrecipe'); ?></option>
<option><?php _e('snack','hrecipe'); ?></option>
</select>
</td>
</tr>


<tr valign="top">
<th scope="row"><?php _e('Number of servings:','hrecipe'); ?></th>
<td>
<select id="item-servings">
<option></option>
<option>1</option>
<option>2</option>
<option>3</option>
<option>4</option>
<option>6</option>
<option>8</option>
<option>12</option>
</select>
</td>
</tr>


<tr valign="top">
<th scope="row"><?php _e('Diet type:','hrecipe'); ?></th>
<td>
<select id="item-diettype">
<option></option>
<option><?php _e('Vegetarian','hrecipe'); ?></option>
<option><?php _e('Pescatarian','hrecipe'); ?></option>
<option><?php _e('Vegan','hrecipe'); ?></option>
<option><?php _e('Macrobiotic','hrecipe'); ?></option>
</select>
</td>
</tr>

<tr valign="top">
<th scope="row"><?php _e('Diet restriction:','hrecipe'); ?></th>
<td>
<select id="item-dietrestriction">
<option></option>
<option><?php _e('Kosher','hrecipe'); ?></option>
<option><?php _e('Halal','hrecipe'); ?></option>
<option><?php _e('Buddhist','hrecipe'); ?></option>
</select>
</td>
</tr>


<tr valign="top">
  <th scope="row"><?php _e('Diet (other):','hrecipe'); ?><br />
  <?php _e('(Check all that apply)','hrecipe'); ?></th>
<td>
<input type="checkbox" id="low_calorie" name="item-dietother" value="Low calorie"><?php _e('Low calorie','hrecipe'); ?>&nbsp;&nbsp;  
<input type="checkbox" id="reduced_fat" name="item-dietother" value="Reduced fat"><?php _e('Reduced fat','hrecipe'); ?>&nbsp;&nbsp; 
<input type="checkbox" id="reduced_carbohydrate" name="item-dietother" value="Reduced carbohydrate"><?php _e('Reduced carbohydrate','hrecipe'); ?><br /> 
<input type="checkbox" id="high_protein" name="item-dietother" value="High protein"><?php _e('High protein','hrecipe'); ?>&nbsp;&nbsp; 
<input type="checkbox" id="gluten_free" name="item-dietother" value="Gluten free"><?php _e('Gluten free','hrecipe'); ?>&nbsp;&nbsp; 
<input type="checkbox" id="raw" name="item-dietother" value="Raw"><?php _e('Raw','hrecipe'); ?>
</td>
</tr>



<tr valign="top">
<th scope="row"><?php _e('Culinary Tradition:','hrecipe'); ?></th>
<td>
<select id="item-culinarytradition">
<option></option>
<option><?php _e('USA (General)','hrecipe'); ?></option>
<option><?php _e('USA (Traditional)','hrecipe'); ?></option>
<option><?php _e('USA (Southern)','hrecipe'); ?></option>
<option><?php _e('USA (Southwestern)','hrecipe'); ?></option>
<option><?php _e('USA (Nouveau)','hrecipe'); ?></option>
<option><?php _e('English','hrecipe'); ?></option>
<option><?php _e('Irish','hrecipe'); ?></option>
<option><?php _e('French','hrecipe'); ?></option>
<option><?php _e('German','hrecipe'); ?></option>
<option><?php _e('Spanish','hrecipe'); ?></option>
<option><?php _e('Chinese','hrecipe'); ?></option>
<option><?php _e('Thai','hrecipe'); ?></option>
<option><?php _e('Mexican','hrecipe'); ?></option>
<option><?php _e('Central American','hrecipe'); ?></option>
<option><?php _e('Russian','hrecipe'); ?></option>
<option><?php _e('Scandinavian','hrecipe'); ?></option>
<option><?php _e('Italian','hrecipe'); ?></option>
<option><?php _e('Persian','hrecipe'); ?></option>
<option><?php _e('Indian (Southern)','hrecipe'); ?></option>
<option><?php _e('Indian (Northern)','hrecipe'); ?></option>
<option><?php _e('Pakistani','hrecipe'); ?></option>
<option><?php _e('African','hrecipe'); ?></option>
<option><?php _e('Middle Eastern','hrecipe'); ?></option>
<option><?php _e('Greek','hrecipe'); ?></option>
</select></td>
</tr>

<tr valign="top">
<th scope="row"><?php _e('My rating:','hrecipe'); ?><br />
<?php _e('(number of stars, leave blank if rating is undesired)','hrecipe'); ?></th>
<td>
<select id="item-rating">
<option></option>
<option>0.5</option>
<option>1.0</option>
<option>1.5</option>
<option>2.0</option>
<option>2.5</option>
<option>3.0</option>
<option>3.5</option>
<option>4.0</option>
<option>4.5</option>
<option>5.0</option>
</select></td>
</tr>
</table>
<p class="submit">
<input type="button" value="Insert" onclick="javascript:submitForm()" />
<input type="button" value="Back" onclick="javascript:abortForm()" />
</p>
</form></div>
</body>
</html>
